package com.tencent.qcloud.tuikit.tuichat.classicui.page;

import android.os.Handler;
import android.os.Looper;
import android.view.View;

import com.tencent.qcloud.tuicore.util.ToastUtil;
import com.tencent.qcloud.tuikit.timcommon.component.TitleBarLayout;
import com.tencent.qcloud.tuikit.timcommon.component.interfaces.ITitleBarLayout;
import com.tencent.qcloud.tuikit.tuichat.R;
import com.tencent.qcloud.tuikit.tuichat.bean.C2CChatInfo;
import com.tencent.qcloud.tuikit.tuichat.bean.ChatInfo;
import com.tencent.qcloud.tuikit.tuichat.presenter.C2CChatPresenter;
import com.tencent.qcloud.tuikit.tuichat.util.TUIChatLog;

public class TUIC2CChatActivity extends TUIBaseChatActivity {
    private static final String TAG = TUIC2CChatActivity.class.getSimpleName();

    private TUIC2CChatFragment chatFragment;

    @Override
    protected int getContentViewLayoutID() {
        return R.layout.chat_activity;
    }

    @Override
    public void initChat(ChatInfo chatInfo) {
        TUIChatLog.i(TAG, "inti chat " + chatInfo);

        if (!(chatInfo instanceof C2CChatInfo)) {
            TUIChatLog.e(TAG, "init C2C chat failed , chatInfo = " + chatInfo);
            ToastUtil.toastShortMessage("init c2c chat failed.");
            return;
        }

        chatFragment = new TUIC2CChatFragment();
        chatFragment.setChatInfo((C2CChatInfo) chatInfo);
        getSupportFragmentManager().beginTransaction().replace(R.id.empty_view, chatFragment).commitAllowingStateLoss();

        new Handler(Looper.getMainLooper()).postDelayed(new Runnable() {
            @Override
            public void run() {
                chatFragment.getTitleBarLayout().getRightGroup().setVisibility(View.VISIBLE);
                chatFragment.getInputView().setInterceptTouchEvent(true);
                chatFragment.getInputView().setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {

                    }
                });
                TitleBarLayout titleBarLayout = chatFragment.getTitleBarLayout();
                titleBarLayout.setTitle("哈哈哈", ITitleBarLayout.Position.MIDDLE);
            }
        }, 1000);
    }

    public TUIC2CChatFragment getChatFragment() {
        return chatFragment;
    }

    @Override
    protected void onDestroy() {
        C2CChatPresenter chatPresenter = null;
        if (chatFragment != null) {
            chatPresenter = chatFragment.getPresenter();
        }
        if (chatPresenter != null) {
            chatPresenter.removeC2CChatEventListener();
        }

        super.onDestroy();
    }
}
