package com.duben.roseplaylet.manager

import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.view.LayoutInflater
import android.widget.TextView
import com.duben.roseplaylet.MintsApplication
import com.duben.roseplaylet.R
import com.duben.roseplaylet.mvp.model.WXInfo
import com.duben.roseplaylet.utils.ToastUtil
import com.duben.roseplaylet.utils.UcropUtils
import com.sunfusheng.marqueeview.MarqueeView
import com.tencent.qcloud.tuikit.timcommon.config.classicui.TUIConfigClassic
import com.tencent.qcloud.tuikit.tuichat.config.classicui.TUIChatConfigClassic
import com.tencent.qcloud.tuikit.tuiconversation.config.classicui.TUIConversationConfigClassic

/**
 *  @author Assen
 *  @date 2025/1/12
 *  @desc
 */
class IMHelper private constructor() {

    init {
        customSet()
    }

    companion object {
        val instance: IMHelper by lazy(mode = LazyThreadSafetyMode.SYNCHRONIZED) {
            IMHelper()
        }
    }

    fun customSet() {
        //隐藏更多菜单中选项（全局）
        TUIChatConfigClassic.hideItemsInMoreMenu(
            TUIChatConfigClassic.CUSTOM
        )
        //设置会话列表、cell 背景色
//        TUIConversationConfigClassic.setListBackground(ColorDrawable(0xFFFFFFF0.toInt()))
//        TUIConversationConfigClassic.setCellBackground(ColorDrawable(0xFFF0FFF0.toInt()))
//        TUIConversationConfigClassic.setPinnedCellBackground(ColorDrawable(0xFFE1FFFF.toInt()))
        //展示在线状态
        TUIConversationConfigClassic.setShowUserOnlineStatusIcon(true)
        //开启消息已读回执
        TUIChatConfigClassic.setMessageReadReceiptNeeded(true)
        //设置系统通知消息文字的字体、颜色和背景色，针对所有系统通知消息生效
        TUIChatConfigClassic.setSystemMessageTextColor(Color.WHITE)
        TUIChatConfigClassic.setSystemMessageFontSize(23)

        TUIChatConfigClassic.setSystemMessageBackground(
            ColorDrawable(MintsApplication.getContext().resources.getColor(R.color.color_07060C))
        )

        // 聊天界面背景色
        TUIChatConfigClassic.setBackground(
            ColorDrawable(MintsApplication.getContext().resources.getColor(R.color.color_07060C))
        )


        TUIConfigClassic.setSendBubbleBackground(
            MintsApplication.getContext().resources.getDrawable(R.drawable.shape_bg_market)
        )
        TUIConfigClassic.setReceiveBubbleBackground(
            MintsApplication.getContext().resources.getDrawable(R.drawable.shape_bg_market)
        )
        TUIChatConfigClassic.setSendTextMessageColor(Color.WHITE)
        TUIChatConfigClassic.setReceiveTextMessageColor(Color.BLACK)
    }

    fun setCustomTopView(wxInfo: WXInfo?) {
        val tipsView = LayoutInflater.from(MintsApplication.getContext())
            .inflate(R.layout.custom_tips_view, null)
        val marqueeView = tipsView.findViewById<MarqueeView<*>>(R.id.marqueeView)
        val message = "请勿轻易通过第三方账户进行红包、转账、借"
        marqueeView.startWithText(message)
        marqueeView.startWithText(
            message,
            com.sunfusheng.marqueeview.R.anim.anim_left_in,
            com.sunfusheng.marqueeview.R.anim.anim_left_out
        )

        val tvWxNo = tipsView.findViewById<TextView>(R.id.tv_wx_no)
        val tvCopy = tipsView.findViewById<TextView>(R.id.tv_copy)
        val tvSend = tipsView.findViewById<TextView>(R.id.tv_send)
        tvCopy.setOnClickListener {
            ToastUtil.show(MintsApplication.getContext(), "微信已复制到剪切板!")
            UcropUtils.clipData(tvWxNo.text.toString())
        }
        tvSend.setOnClickListener {

        }

        TUIChatConfigClassic.setCustomTopView(tipsView)
    }
}