package com.duben.roseplaylet.mvp.presenters

import com.duben.library.net.neterror.BaseSubscriber
import com.duben.library.net.neterror.Throwable
import com.duben.roseplaylet.manager.AppHttpManager
import com.duben.roseplaylet.mvp.model.BaseResponse
import com.duben.roseplaylet.mvp.model.NineListBean
import com.duben.roseplaylet.mvp.views.UserInfoView

class UserInfoPresenter : BasePresenter<UserInfoView>() {

    fun getMorePage(toUid: String) {
        val vo = hashMapOf<String, Any>()
        vo["toUid"] = toUid
        AppHttpManager.getInstance(loanApplication)
            .call(loanService.getMorePage(vo),
                object : BaseSubscriber<BaseResponse<NineListBean>>() {
                    override fun onCompleted() {
                        if (isLinkView) return
                        view.hideLoading()
                    }

                    override fun onNext(baseResponse: BaseResponse<NineListBean>) {
                        if (isLinkView) return

                        view.hideLoading()
                        val code = baseResponse.status
                        val message = baseResponse.message

                        when (code) {
//                            200 -> view.getMorePageSuc()
                            else -> {
                                view.showToast(message)
                                view.getMorePageFail()
                            }
                        }
                    }

                    override fun onError(e: Throwable?) {
                        if (isLinkView) return
                        view.hideLoading()
                        view.showToast(e?.message)
                        view.getMorePageFail()
                    }
                })
    }

}