package com.duben.roseplaylet.ui.activitys

import android.os.Bundle
import android.view.KeyEvent
import android.view.View
import com.airbnb.lottie.LottieAnimationView
import com.airbnb.lottie.LottieComposition
import com.airbnb.lottie.LottieCompositionFactory
import com.airbnb.lottie.LottieDrawable
import com.duben.library.utils.nodoubleclick.AntiShake
import com.duben.roseplaylet.R
import com.duben.roseplaylet.ui.activitys.base.BaseActivity
import com.duben.roseplaylet.ui.widgets.SimpleCountDownTimer
import kotlinx.android.synthetic.main.activity_alipaytime.*


/**
 * 描述：支付倒计时
 * 作者：孟崔广
 */
class AlipayTimeActivity : BaseActivity(), View.OnClickListener {
    companion object {
        const val ALIPAY_TIME = "alipay_time"
    }

    private var countDownTimer: SimpleCountDownTimer? = null
    private var alipaytime = 0

    override fun getContentViewLayoutID() = R.layout.activity_alipaytime

    override fun isApplyKitKatTranslucency() = false

    override fun toggleOverridePendingTransition() = true

    override fun getOverridePendingTransitionMode() = TransitionMode.FADE

    override fun getBundleExtras(extras: Bundle?) {
        super.getBundleExtras(extras)
        extras?.let {
            alipaytime = it.getInt(ALIPAY_TIME, 0)
        }
    }

    override fun initViewsAndEvents() {
        ivBack.setOnClickListener(this)

        countDownTimer = SimpleCountDownTimer(
            ((alipaytime)*1000).toLong(),
            tv_alipaytime
        ).setOnFinishListener {
            finish()
        }.start() as SimpleCountDownTimer?
    }

    override fun finish() {
        super.finish()
        overridePendingTransition(0, R.anim.fade_out)
    }

    override fun onDestroy() {
        super.onDestroy()
        countDownTimer?.cancel()
    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        return if (keyCode == KeyEvent.KEYCODE_BACK) {
            true
        } else super.onKeyDown(keyCode, event)
    }

    override fun onClick(v: View) {
        if (AntiShake.check(v.id)) return

        when (v.id) {
            R.id.ivBack -> {
                finish()
            }
        }
    }

    private fun playCollectAnim(view: LottieAnimationView) {
        val lottieDrawable = LottieDrawable()
        LottieCompositionFactory.fromAsset(context, "home_collect.json")
            .addListener { result: LottieComposition? ->
                lottieDrawable.setImagesAssetsFolder("images/")
                lottieDrawable.composition = result
                lottieDrawable.loop(false)
                lottieDrawable.playAnimation()
            }
        view.setImageDrawable(lottieDrawable)
    }
}