package com.duben.roseplaylet.ui.activitys

import android.Manifest
import android.app.Activity
import android.content.Intent
import android.content.pm.ActivityInfo
import android.graphics.Color
import android.text.TextUtils
import android.view.View
import android.widget.EditText
import android.widget.ImageView
import android.widget.TextView
import com.duben.library.utils.GlideUtils
import com.duben.roseplaylet.R
import com.duben.roseplaylet.ui.activitys.base.BaseActivity
import com.duben.library.utils.nodoubleclick.AntiShake
import com.duben.roseplaylet.common.OssType
import com.duben.roseplaylet.common.UserProfile
import com.duben.roseplaylet.manager.OssManager
import com.duben.roseplaylet.manager.UserManager
import com.duben.roseplaylet.mvp.model.PickBean
import com.duben.roseplaylet.ui.widgets.pick.SinglePickDialog
import com.duben.roseplaylet.utils.GlideEngine
import com.duben.roseplaylet.utils.UcropUtils
import com.luck.picture.lib.PictureSelector
import com.luck.picture.lib.compress.Luban
import com.luck.picture.lib.config.PictureConfig
import com.luck.picture.lib.config.PictureMimeType
import com.luck.picture.lib.entity.LocalMedia
import com.luck.picture.lib.style.PictureWindowAnimationStyle
import com.luck.picture.lib.thread.PictureThreadUtils
import com.luck.picture.lib.tools.DateUtils
import com.luck.picture.lib.tools.SdkVersionUtils
import com.tbruyelle.rxpermissions.RxPermissions
import com.yalantis.ucrop.UCrop
import kotlinx.android.synthetic.main.activity_edit_profile.*
import kotlinx.android.synthetic.main.activity_edit_profile.layout_gxbq
import kotlinx.android.synthetic.main.activity_edit_profile.layout_jyfw
import kotlinx.android.synthetic.main.activity_edit_profile.layout_sg
import kotlinx.android.synthetic.main.activity_edit_profile.layout_sx
import kotlinx.android.synthetic.main.activity_edit_profile.layout_tz
import kotlinx.android.synthetic.main.activity_edit_profile.layout_zy
import kotlinx.android.synthetic.main.activity_real_auth.*
import kotlinx.android.synthetic.main.header_layout.*
import java.io.File

class EditProfileActivity : BaseActivity(), View.OnClickListener {

    private lateinit var ivAvatar: ImageView

    private var avatarUrl = ""

    private val userManager by lazy { UserManager.getInstance() }

    override fun getContentViewLayoutID() = R.layout.activity_edit_profile

    override fun isApplyKitKatTranslucency() = false

    private var mSinglePickDialog: SinglePickDialog? = null

    override fun initViewsAndEvents() {
        tv_title.text = "编辑资料"
        tv_title.setTextColor(Color.WHITE)
        iv_left_icon.visibility = View.VISIBLE
        iv_left_icon.setImageResource(R.mipmap.ic_arrow_white)

        initView()
        initListener()
    }

    private fun initView() {
        // 昵称
        ivAvatar = layout_avatar.findViewById<ImageView>(R.id.iv_avatar)
        layout_avatar.findViewById<TextView>(R.id.label_tv).text = "点击修改头像"
        layout_avatar.setOnClickListener(this)

        // 昵称
        layout_nickname.findViewById<TextView>(R.id.label_start).text = "昵称"
        val nicknameEt = layout_nickname.findViewById<EditText>(R.id.label_et)
        if (!TextUtils.isEmpty("")) {
            nicknameEt.setText("")
        } else {
            nicknameEt.hint = "填写昵称"
            nicknameEt.setText("")
        }
        // 微信
        layout_wechat.findViewById<TextView>(R.id.label_start).text = "微信"
        val wechatEt = layout_wechat.findViewById<EditText>(R.id.label_et)
        if (!TextUtils.isEmpty("")) {
            wechatEt.setText("")
        } else {
            wechatEt.hint = "填写微信号"
            wechatEt.setText("")
        }
        // 个性签名
        layout_gxqm.findViewById<TextView>(R.id.label_start).text = "个性签名"
        val gxqmEt = layout_wechat.findViewById<EditText>(R.id.label_et)
        if (!TextUtils.isEmpty("")) {
            gxqmEt.setText("")
        } else {
            gxqmEt.hint = "您还没有设置签名哦"
            gxqmEt.setText("")
        }

        // 年龄
        layout_nl.findViewById<TextView>(R.id.label_start).text = UserProfile.PROFILE_NL.str
        val nlTv = layout_nl.findViewById<TextView>(R.id.label_tv)
        if (!TextUtils.isEmpty("")) {
            nlTv.text = ""
        } else {
            nlTv.text = "不详"
        }
        layout_nl.setOnClickListener(this)
        // 职业
        layout_zy.findViewById<TextView>(R.id.label_start).text = UserProfile.PROFILE_ZY.str
        val zyTv = layout_zy.findViewById<TextView>(R.id.label_tv)
        if (!TextUtils.isEmpty("")) {
            zyTv.text = ""
        } else {
            zyTv.text = "不详"
        }
        layout_zy.setOnClickListener(this)
        // 身高
        layout_sg.findViewById<TextView>(R.id.label_start).text = UserProfile.PROFILE_SG.str
        val sgTv = layout_sg.findViewById<TextView>(R.id.label_tv)
        if (!TextUtils.isEmpty("")) {
            sgTv.text = ""
        } else {
            sgTv.text = "不详"
        }
        layout_sg.setOnClickListener(this)
        // 体重
        layout_tz.findViewById<TextView>(R.id.label_start).text = UserProfile.PROFILE_TZ.str
        val tzTv = layout_tz.findViewById<TextView>(R.id.label_tv)
        if (!TextUtils.isEmpty("")) {
            tzTv.text = ""
        } else {
            tzTv.text = "不详"
        }
        layout_tz.setOnClickListener(this)
        // 身形
        layout_sx.findViewById<TextView>(R.id.label_start).text = UserProfile.PROFILE_SX.str
        val sxTv = layout_sx.findViewById<TextView>(R.id.label_tv)
        if (!TextUtils.isEmpty("")) {
            sxTv.text = ""
        } else {
            sxTv.text = "不详"
        }
        layout_sx.setOnClickListener(this)
        // 交友范围
        layout_jyfw.findViewById<TextView>(R.id.label_start).text = UserProfile.PROFILE_JYFW.str
        val jyfwTv = layout_jyfw.findViewById<TextView>(R.id.label_tv)
        if (!TextUtils.isEmpty("")) {
            jyfwTv.text = ""
        } else {
            jyfwTv.text = "不详"
        }
        // 交友节目
        layout_jyjm.findViewById<TextView>(R.id.label_start).text = UserProfile.PROFILE_JYFW.str
        val jyjmTv = layout_jyjm.findViewById<TextView>(R.id.label_tv)
        if (!TextUtils.isEmpty("")) {
            jyjmTv.text = ""
        } else {
            jyjmTv.text = "不详"
        }
        layout_jyjm.setOnClickListener(this)
        // 个性标签
        layout_gxbq.findViewById<TextView>(R.id.label_start).text = UserProfile.PROFILE_GXBQ.str
        val gxbqTv = layout_gxbq.findViewById<TextView>(R.id.label_tv)
        if (!TextUtils.isEmpty("")) {
            gxbqTv.text = ""
        } else {
            gxbqTv.text = "不详"
        }
        layout_gxbq.setOnClickListener(this)
    }

    private fun getPickerData(pickerType: String): MutableList<PickBean> {
        val data = mutableListOf<PickBean>()

        val stringData = when (pickerType) {
            UserProfile.PROFILE_SG.str -> {
                UserProfile.PROFILE_SG.arr
            }
            UserProfile.PROFILE_TZ.str -> {
                UserProfile.PROFILE_TZ.arr
            }
            UserProfile.PROFILE_SX.str -> {
                UserProfile.PROFILE_SX.arr
            }
            UserProfile.PROFILE_JYFW.str -> {
                UserProfile.PROFILE_JYFW.arr
            }
            UserProfile.PROFILE_ZY.str -> {
                UserProfile.PROFILE_ZY.arr
            }
            UserProfile.PROFILE_JYJM.str -> {
                UserProfile.PROFILE_JYJM.arr
            }
            else -> {
                UserProfile.UNKNOWN.arr
            }
        }

        for (stringDatum in stringData) {
            data.add(PickBean(stringDatum, false))
        }

        return data
    }

    private fun showPickDialog(pickerType: String, defaultValue: String) {
        when (pickerType) {
            UserProfile.PROFILE_SG.str -> {
                mSinglePickDialog = SinglePickDialog(
                    this,
                    UserProfile.PROFILE_SG.str,
                    getPickerData(UserProfile.PROFILE_SG.str),
                    defaultValue
                )
                mSinglePickDialog?.setPickResultListener(object :
                    SinglePickDialog.OnPickResultListener {
                    override fun onPickResult(result: String) {

                    }
                })
                mSinglePickDialog?.show()
            }
            UserProfile.PROFILE_TZ.str -> {
                mSinglePickDialog = SinglePickDialog(
                    this,
                    UserProfile.PROFILE_TZ.str,
                    getPickerData(UserProfile.PROFILE_TZ.str),
                    defaultValue
                )
                mSinglePickDialog?.setPickResultListener(object :
                    SinglePickDialog.OnPickResultListener {
                    override fun onPickResult(result: String) {

                    }
                })
                mSinglePickDialog?.show()
            }
            UserProfile.PROFILE_SX.str -> {
                mSinglePickDialog = SinglePickDialog(
                    this,
                    UserProfile.PROFILE_SX.str,
                    getPickerData(UserProfile.PROFILE_SX.str),
                    defaultValue
                )
                mSinglePickDialog?.setPickResultListener(object :
                    SinglePickDialog.OnPickResultListener {
                    override fun onPickResult(result: String) {

                    }
                })
                mSinglePickDialog?.show()
            }
            UserProfile.PROFILE_JYJM.str -> {
                mSinglePickDialog = SinglePickDialog(
                    this,
                    UserProfile.PROFILE_JYJM.str,
                    getPickerData(UserProfile.PROFILE_JYJM.str),
                    defaultValue
                )
                mSinglePickDialog?.setPickResultListener(object :
                    SinglePickDialog.OnPickResultListener {
                    override fun onPickResult(result: String) {

                    }
                })
                mSinglePickDialog?.show()
            }
            UserProfile.PROFILE_ZY.str -> {
                mSinglePickDialog = SinglePickDialog(
                    this,
                    UserProfile.PROFILE_ZY.str,
                    getPickerData(UserProfile.PROFILE_ZY.str),
                    defaultValue
                )
                mSinglePickDialog?.setPickResultListener(object :
                    SinglePickDialog.OnPickResultListener {
                    override fun onPickResult(result: String) {

                    }
                })
                mSinglePickDialog?.show()
            }
            else -> {}
        }
    }

    override fun onClick(v: View?) {
        if (AntiShake.check(v?.id)) return

        when (v?.id) {
            R.id.iv_left_icon -> finish()
            R.id.layout_avatar -> {

            }
            R.id.layout_nl -> {
                showPickDialog(UserProfile.PROFILE_NL.str, "")
            }
            R.id.layout_zy -> {
                showPickDialog(UserProfile.PROFILE_ZY.str, "")
            }
            R.id.layout_sg -> {
                showPickDialog(UserProfile.PROFILE_SG.str, "")
            }
            R.id.layout_tz -> {
                showPickDialog(UserProfile.PROFILE_TZ.str, "")
            }
            R.id.layout_sx -> {
                showPickDialog(UserProfile.PROFILE_SX.str, "")
            }
            R.id.layout_jyfw -> {

            }
            R.id.layout_jyjm -> {
                showPickDialog(UserProfile.PROFILE_JYJM.str, "")
            }
            R.id.layout_gxbq -> {
                readyGoForResult(
                    UserLabelActivity::class.java,
                    RealAuthActivity.USER_LABEL_REQUEST_CODE
                )
            }
        }
    }

    private fun initListener() {
        iv_left_icon.setOnClickListener(this)
    }

    private fun showAlbum() {
        val windowAnimationStyle = PictureWindowAnimationStyle()
        windowAnimationStyle.ofAllAnimation(
            com.luck.picture.lib.R.anim.picture_anim_up_in,
            com.luck.picture.lib.R.anim.picture_anim_down_out
        )

        RxPermissions(this)
            .request(Manifest.permission.READ_EXTERNAL_STORAGE)
            .subscribe { granted: Boolean ->
                if (granted) {
                    val isEnableCrop = false
                    PictureSelector.create(this)
                        .openGallery(PictureMimeType.ofImage())
                        .theme(R.style.picture_WeChat_style) // 微信主题色
                        .isWeChatStyle(true) // 微信样式
                        .isCamera(false) //列表是否显示拍照按钮
                        .isZoomAnim(isEnableCrop)//图片选择缩放效果
                        .isEnableCrop(isEnableCrop)//是否开启裁剪
                        .setPictureWindowAnimationStyle(windowAnimationStyle)
                        .withAspectRatio(2, 4)
                        .isCompress(true)//是否压缩
                        .compressFocusAlpha(false)//压缩后是否保持图片的透明通道
                        .minimumCompressSize(200)// 小于多少kb的图片不压缩
                        .compressQuality(60)//图片压缩后输出质量
                        .synOrAsy(true)//开启同步or异步压缩
                        .maxSelectNum(10)
                        .setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED)//屏幕旋转方向
                        .selectionMode(PictureConfig.MULTIPLE)//单选or多选
                        .imageEngine(GlideEngine.createGlideEngine())// 图片加载引擎
                        .forResult(PictureConfig.CHOOSE_REQUEST)
                } else {
                    showMissingPermissionDialog("存储")
                }
            }
    }

    /**
     * 鲁班压缩
     */
    private fun luban(cutPath: String) {
        val media = LocalMedia(cutPath, 0, false, 1, 0, PictureMimeType.ofImage())
        media.cutPath = cutPath
        if (SdkVersionUtils.checkedAndroid_Q()) {
            media.androidQToPath = cutPath
        }

        runOnUiThread {
            showLoading("加载中...")
        }

        val newFileName = DateUtils.getCreateFileName("IMG_CMP_") + ".jpeg"

        PictureThreadUtils.executeByIo(object : PictureThreadUtils.SimpleTask<List<File>>() {
            @Throws(Exception::class)
            override fun doInBackground(): List<File> {
                return Luban.with(mContext)
                    .loadMediaData<LocalMedia>(arrayListOf(media))
                    .ignoreBy(200)
                    .isCamera(false)
                    .setCompressQuality(80)
                    .setTargetDir(null)
                    .setFocusAlpha(false)
                    .setNewCompressFileName(newFileName).get()
            }

            override fun onSuccess(files: List<File>) {
                uploadOss(files[0].path, OssType.PHOTO.type)
            }

            override fun onFail(t: Throwable?) {
                super.onFail(t)
                hideLoading()
            }
        })
    }

    /**
     * 上传到oss服务器
     */
    private fun uploadOss(localFile: String, type: String) {
        OssManager.instance?.run {
            uploadImg(type, localFile)
            setOssUploadImgListener(object : OssManager.OssUploadImgListener {
                override fun uploadImgFailForSubthread(errorInfo: String) {
                    runOnUiThread {
                        showToast(errorInfo)
                    }
                }

                override fun uploadImgSuccessForSubthread(imgPath: String?) {
                    runOnUiThread {
                        if (TextUtils.isEmpty(imgPath)) {
                            showToast("图片异常，请重新添加")
                            return@runOnUiThread
                        }
                        avatarUrl = imgPath!!
                        GlideUtils.loadImageView(
                            this@EditProfileActivity,
                            avatarUrl, ivAvatar
                        )
                    }
                }
            })
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (resultCode) {
            Activity.RESULT_OK -> {
                when (requestCode) {
                    // 相册获取图片
                    PictureConfig.CHOOSE_REQUEST -> {
                        val selectList: List<LocalMedia> =
                            PictureSelector.obtainMultipleResult(data)
                        val img = selectList[0]
                        uploadOss(img.compressPath, OssType.PHOTO.type)
                    }
                    // 裁剪获取图片
                    UcropUtils.UCROP_REQUEST_CODE -> {
                        data?.let {
                            val uri = UCrop.getOutput(it)
                            luban(uri?.path!!)
                        }
                    }
                }
            }
            UCrop.RESULT_ERROR -> {
                showToast("裁剪失败，请再试一下")
            }
            RealAuthActivity.USER_LABEL_REQUEST_CODE -> {
//                val arrayExtra = data?.getStringArrayExtra(RealAuthActivity.USER_LABEL_DATA)
            }
        }
    }
}
