package com.duben.roseplaylet.ui.activitys

import android.os.Bundle
import android.os.Handler
import android.os.Looper
import com.duben.roseplaylet.MintsApplication
import com.duben.roseplaylet.R
import com.duben.roseplaylet.utils.ToastUtil
import com.gyf.barlibrary.ImmersionBar
import com.tencent.qcloud.tuikit.timcommon.component.interfaces.ITitleBarLayout
import com.tencent.qcloud.tuikit.tuichat.bean.C2CChatInfo
import com.tencent.qcloud.tuikit.tuichat.bean.ChatInfo
import com.tencent.qcloud.tuikit.tuichat.classicui.page.TUIBaseChatActivity
import com.tencent.qcloud.tuikit.tuichat.classicui.page.TUIC2CChatFragment
import com.tencent.qcloud.tuikit.tuichat.presenter.C2CChatPresenter
import com.tencent.qcloud.tuikit.tuichat.util.TUIChatLog

/**
 *  @author Assen
 *  @date 2025/1/12
 *  @desc
 */
class IMActivity : TUIBaseChatActivity() {

    companion object {
        private val TAG = IMActivity::class.java.simpleName
    }

    private lateinit var chatFragment: TUIC2CChatFragment

    override fun onCreate(savedInstanceState: Bundle?) {
        ImmersionBar.with(this).statusBarDarkFont(false, 0.5f).init()
        super.onCreate(savedInstanceState)
    }

    override fun initChat(chatInfo: ChatInfo) {
        TUIChatLog.i(TAG, "inti chat $chatInfo")
        if (chatInfo !is C2CChatInfo) {
            TUIChatLog.e(TAG, "init C2C chat failed , chatInfo = $chatInfo")
            ToastUtil.show(MintsApplication.getContext(), "init c2c chat failed.")
            return
        }
        chatFragment = TUIC2CChatFragment()
        chatFragment.chatInfo = chatInfo
        supportFragmentManager.beginTransaction()
            .replace(R.id.chat_fragment_container, chatFragment)
            .commitAllowingStateLoss()

        initChatSetting()
    }

    private fun initChatSetting() {
        Handler(Looper.getMainLooper()).postDelayed({
//            chatFragment.titleBarLayout.rightGroup.visibility = View.VISIBLE

            chatFragment.inputView.setInterceptTouchEvent(true)
            chatFragment.inputView.setBackgroundColor(
                resources.getColor(R.color.color_171619)
            )
            chatFragment.inputView.setOnClickListener {

            }
            val titleBarLayout = chatFragment.titleBarLayout
//            titleBarLayout.setBackgroundColor(
//                resources.getColor(R.color.color_15141A)
//            )
            titleBarLayout.setTitle("哈哈哈", ITitleBarLayout.Position.MIDDLE)
            titleBarLayout.setRightIcon(R.mipmap.ic_alipay)
            titleBarLayout.rightGroup.setOnClickListener {
                ToastUtil.show(MintsApplication.getContext(), "OOOOOOO")
            }
        }, 100)
    }

    override fun onDestroy() {
        val chatPresenter: C2CChatPresenter? = chatFragment.presenter
        chatPresenter?.removeC2CChatEventListener()
        super.onDestroy()
    }

    override fun getContentViewLayoutID(): Int {
        return R.layout.activity_im
    }


}