package com.duben.roseplaylet.ui.activitys

import android.view.View
import com.duben.roseplaylet.R
import com.duben.roseplaylet.ui.activitys.base.BaseActivity
import com.duben.library.utils.nodoubleclick.AntiShake
import com.duben.roseplaylet.mvp.model.NineListBean
import com.duben.roseplaylet.mvp.presenters.UserInfoPresenter
import com.duben.roseplaylet.mvp.views.UserInfoView
import kotlinx.android.synthetic.main.activity_user_info.*
import kotlinx.android.synthetic.main.header_layout.*

/**
 * 描述：用户信息
 */
class UserInfoActivity : BaseActivity(), View.OnClickListener, UserInfoView {

    private val userInfoPresenter by lazy { UserInfoPresenter() }

    override fun getContentViewLayoutID() = R.layout.activity_user_info

    override fun isApplyKitKatTranslucency() = false

    override fun initViewsAndEvents() {
        userInfoPresenter.attachView(this)

        initView()
        initListener()
    }

    private fun initView() {
        iv_faith_value.setOnClickListener(this)
        ll_jwyzr.setOnClickListener(this)
        ll_dzh.setOnClickListener(this)
    }

    override fun onClick(v: View?) {
        if (AntiShake.check(v?.id)) return

        when (v?.id) {
            R.id.iv_left_icon -> finish()
            R.id.iv_faith_value -> { // 查看诚信值

            }
            R.id.ll_jwyzr -> { // 加为意中人

            }
            R.id.ll_dzh -> { // 打招呼

            }
        }
    }

    private fun initListener() {
//        iv_left_icon.setOnClickListener(this)
    }

    override fun onDestroy() {
        userInfoPresenter.detachView()
        super.onDestroy()
    }

    override fun getMorePageSuc(data: NineListBean) {

    }

    override fun getMorePageFail() {
    }
}
