package com.duben.roseplaylet.ui.activitys

import android.view.View
import com.duben.library.utils.GlideUtils
import com.duben.roseplaylet.R
import com.duben.roseplaylet.ui.activitys.base.BaseActivity
import com.duben.library.utils.nodoubleclick.AntiShake
import com.duben.roseplaylet.mvp.model.NineListBean
import com.duben.roseplaylet.mvp.presenters.UserInfoPresenter
import com.duben.roseplaylet.mvp.views.UserInfoView
import kotlinx.android.synthetic.main.activity_user_profile.*

/**
 * 描述：用户信息
 */
class UserProfileActivity : BaseActivity(), View.OnClickListener, UserInfoView {

    private var headerImg =
        "https://pics0.baidu.com/feed/810a19d8bc3eb13589ac35cdb62485dcfd1f4422.jpeg"

    private val userInfoPresenter by lazy { UserInfoPresenter() }

    override fun getContentViewLayoutID() = R.layout.activity_user_profile

    override fun isApplyKitKatTranslucency() = false

    override fun initViewsAndEvents() {
        userInfoPresenter.attachView(this)

        initView()
        initListener()
    }

    private fun initView() {
        GlideUtils.loadImageView(this, headerImg, iv_header)
    }

    override fun onClick(v: View?) {
        if (AntiShake.check(v?.id)) return

        when (v?.id) {
            R.id.iv_left_icon -> finish()
        }
    }

    private fun initListener() {
//        iv_left_icon.setOnClickListener(this)
    }



    override fun getMorePageSuc(data: NineListBean) {

    }

    override fun getMorePageFail() {
    }

    override fun onDestroy() {
        userInfoPresenter.detachView()
        super.onDestroy()
    }

}
