package com.duben.roseplaylet.ui.activitys

import android.view.View
import com.duben.library.utils.nodoubleclick.AntiShake
import com.duben.roseplaylet.R
import com.duben.roseplaylet.manager.AlipayAuthManager
import com.duben.roseplaylet.ui.activitys.base.BaseActivity
import kotlinx.android.synthetic.main.activity_wallet.*
import kotlinx.android.synthetic.main.header_layout.*

/**
 * 描述：钱包
 * 作者：孟崔广
 * 时间：2025/1/9 12:39
 */
class WalletActivity : BaseActivity(), View.OnClickListener {

    override fun getContentViewLayoutID() = R.layout.activity_wallet

    override fun isApplyKitKatTranslucency() = false

    override fun initViewsAndEvents() {
        iv_left_icon.visibility = View.VISIBLE
        iv_left_icon.setImageResource(R.mipmap.ic_arrow_back)


        initListener()
    }

    override fun onClick(v: View?) {
        if (AntiShake.check(v?.id)) return

        when (v?.id) {
            R.id.iv_left_icon -> finish()
            R.id.btn_alipayauth -> {
                showToast("支付宝拉起授权")

                AlipayAuthManager.authV2(this@WalletActivity,
                    object : AlipayAuthManager.AuthListener {
                        override fun authSuccess() {
                            showToast("支付宝授权成功")
                        }

                        override fun authFail(resultStatus: String) {
                            showToast("支付宝授权失败 " + resultStatus)
                        }
                    })
            }
        }
    }

    private fun initListener() {
        iv_left_icon.setOnClickListener(this)
        btn_alipayauth.setOnClickListener(this)
    }
}
