package com.duben.roseplaylet.ui.activitys

import android.view.View
import com.duben.roseplaylet.R
import com.duben.roseplaylet.ui.activitys.base.BaseActivity
import com.duben.library.utils.nodoubleclick.AntiShake
import com.duben.roseplaylet.mvp.presenters.WriteMoodPresenter
import com.duben.roseplaylet.mvp.views.WriteMoodView
import kotlinx.android.synthetic.main.activity_write_mood.*
import kotlinx.android.synthetic.main.header_layout.*

/**
 * 描述：写心情
 */
class WriteMoodActivity : BaseActivity(), View.OnClickListener, WriteMoodView {

    private val writeMoodPresenter by lazy { WriteMoodPresenter() }

    override fun getContentViewLayoutID() = R.layout.activity_write_mood

    override fun isApplyKitKatTranslucency() = false

    override fun initViewsAndEvents() {
        writeMoodPresenter.attachView(this)

//        tv_title.text = "发布动态"
        initListener()
    }

    override fun onClick(v: View?) {
        if (AntiShake.check(v?.id)) return

        when (v?.id) {
            R.id.iv_left_icon -> finish()
            R.id.btn_publish -> {

            }
        }
    }

    private fun initListener() {
        iv_left_icon.setOnClickListener(this)
        btn_publish.setOnClickListener(this)
    }

    override fun onDestroy() {
        super.onDestroy()
        writeMoodPresenter.detachView()
    }
}
