package com.duben.roseplaylet.ui.adapter

import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentActivity
import androidx.viewpager2.adapter.FragmentStateAdapter

class CommonTabAdapter(
    private val data: List<String>,
    private val fragments: List<Fragment>,
    activity: FragmentActivity
) :
    FragmentStateAdapter(activity) {

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }

    override fun getItemCount() = data.size

    override fun createFragment(position: Int): Fragment {
        return fragments[position]
    }

    override fun containsItem(itemId: Long): Boolean {
        for (i in data.indices) {
            if (i.toLong() == itemId) {
                return true
            }
        }
        return false
    }

}