package com.duben.roseplaylet.ui.fragment

import android.os.Bundle
import androidx.fragment.app.Fragment
import com.duben.roseplaylet.R
import com.duben.roseplaylet.ui.activitys.CommonTabActivity
import com.duben.roseplaylet.ui.fragment.base.LazyLoadBaseFragment
import com.scwang.smartrefresh.layout.api.RefreshLayout
import com.scwang.smartrefresh.layout.listener.OnRefreshListener

/**
 *  @author Assen
 *  @date 2024/1/5
 *  @desc
 */
class CommonListFragment : LazyLoadBaseFragment(), OnRefreshListener {

    companion object {

        private const val FRAGMENT_COMMON_TYPE = "FRAGMENT_COMMON_TYPE"

        fun newInstance(type: String): Fragment {
            val args = Bundle()
            args.putString(FRAGMENT_COMMON_TYPE, type)
            val fragment = CommonListFragment()
            fragment.arguments = args
            return fragment
        }
    }


    private var mType = CommonTabActivity.ACTIVITY_TYPE_YZR

    override fun initViewsAndEvents() {
        arguments?.run {
            mType = getString(FRAGMENT_COMMON_TYPE, CommonTabActivity.ACTIVITY_TYPE_YZR)
        }

        when (mType) {
            CommonTabActivity.ACTIVITY_TYPE_YZR -> initYzr()
            else -> {}
        }
    }

    private fun initYzr() {

    }

    override fun getContentViewLayoutID() = R.layout.fragment_common_tab

    override fun onFragmentFirstVisible() {
        super.onFragmentFirstVisible()

    }

    override fun onRefresh(refreshLayout: RefreshLayout) {
        refreshLayout.finishRefresh()
    }
}