package com.duben.roseplaylet.ui.fragment

import android.view.View
import com.duben.library.utils.nodoubleclick.AntiShake
import com.duben.roseplaylet.R
import com.duben.roseplaylet.common.AppConfig
import com.duben.roseplaylet.common.Constant
import com.duben.roseplaylet.manager.UserManager
import com.duben.roseplaylet.mvp.model.VedioBean
import com.duben.roseplaylet.mvp.presenters.InvitePresenter
import com.duben.roseplaylet.mvp.views.InviteView
import com.duben.roseplaylet.ui.adapter.InviteAdapter
import com.duben.roseplaylet.ui.fragment.base.LazyLoadBaseFragment
import com.duben.roseplaylet.ui.widgets.ShareDialog
import kotlinx.android.synthetic.main.fragment_main_invite.*

/**
 * 描述：邀请有奖
 * 作者：孟崔广
 * 时间：2023/12/27 11:30
 */
class InviteFragment : LazyLoadBaseFragment(), InviteView, View.OnClickListener {

    private val invitePresenter by lazy { InvitePresenter() }

    private val userManager by lazy { UserManager.getInstance() }
    private var inviteAdapter: InviteAdapter? = null
    private val inviteData: ArrayList<VedioBean> = arrayListOf()

    override fun getContentViewLayoutID() = R.layout.fragment_main_invite

    override fun initViewsAndEvents() {
        invitePresenter.attachView(this)
        btn_invite.setOnClickListener(this)
    }

    override fun onFragmentFirstVisible() {
        super.onFragmentFirstVisible()

        initRecy()
    }


    override fun onDestroy() {
        super.onDestroy()
        invitePresenter.detachView()
    }

    override fun onFragmentResume() {
        super.onFragmentResume()

        if (AppConfig.fragmentClickFlag == Constant.FRAGMENT_CLICK_THREE) {

        }
    }

    override fun onClick(v: View?) {
        if (AntiShake.check(v?.id)) return

        when (v?.id) {
            R.id.btn_invite -> {
                shareImgDialog()
            }
        }
    }

    private fun initRecy() {
        inviteAdapter = InviteAdapter(requireContext(), inviteData)
        recy_invite.adapter = inviteAdapter
    }

    /**
     * 图片分享
     */
    private fun shareImgDialog() {
        val shareDialog = ShareDialog(requireActivity())
        shareDialog.setOnShareOKListener(object : ShareDialog.OnShareOKListener {
            override fun onShareOk() {
            }
        })
        val content = "送你一个赚钱的新模式，\r\n快点加入跟我一起赚钱吧"
        shareDialog.setShareAvatar("https://mints-pkg.oss-cn-beijing.aliyuncs.com/pkg/img/ic_my_coin.png")
        shareDialog.setShareTitle("Hi,我是用户" + userManager.codeId)
        shareDialog.setShareContent(content)
        shareDialog.show()
    }
}