package com.duben.roseplaylet.ui.fragment

import android.os.Bundle
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.duben.library.utils.nodoubleclick.AntiShake
import com.duben.roseplaylet.R
import com.duben.roseplaylet.common.AppConfig
import com.duben.roseplaylet.common.Constant
import com.duben.roseplaylet.manager.UserManager
import com.duben.roseplaylet.ui.activitys.CommonTabActivity
import com.duben.roseplaylet.ui.fragment.base.LazyLoadBaseFragment
import kotlinx.android.synthetic.main.fragment_system_msg.*

class SystemMsgFragment : LazyLoadBaseFragment(), View.OnClickListener {

    private val userManager by lazy { UserManager.getInstance() }

    override fun getContentViewLayoutID() = R.layout.fragment_system_msg

    override fun initViewsAndEvents() {
        initView()
    }

    private fun initView() {
        // 站内信
        ll_znx.findViewById<TextView>(R.id.tv_title).text = "站内信"
        ll_znx.findViewById<ImageView>(R.id.iv_icon).setImageResource(R.mipmap.ic_launcher_main)

        // 打招呼
        ll_dzh.findViewById<TextView>(R.id.tv_title).text = "打招呼"
        ll_dzh.findViewById<ImageView>(R.id.iv_icon).setImageResource(R.mipmap.ic_launcher_main)

        // 谁看过我
        ll_skgw.findViewById<TextView>(R.id.tv_title).text = "谁看过我"
        ll_skgw.findViewById<ImageView>(R.id.iv_icon).setImageResource(R.mipmap.ic_launcher_main)

        // 谁联系我
        ll_slxw.findViewById<TextView>(R.id.tv_title).text = "谁联系我"
        ll_slxw.findViewById<ImageView>(R.id.iv_icon).setImageResource(R.mipmap.ic_launcher_main)

        // 系统通知
        ll_xttz.findViewById<TextView>(R.id.tv_title).text = "系统通知"
        ll_xttz.findViewById<ImageView>(R.id.iv_icon).setImageResource(R.mipmap.ic_launcher_main)

        // 评论通知
        ll_pltz.findViewById<TextView>(R.id.tv_title).text = "评论通知"
        ll_pltz.findViewById<ImageView>(R.id.iv_icon).setImageResource(R.mipmap.ic_launcher_main)

        // 相亲通知
        ll_xqtz.findViewById<TextView>(R.id.tv_title).text = "相亲通知"
        ll_xqtz.findViewById<ImageView>(R.id.iv_icon).setImageResource(R.mipmap.ic_launcher_main)


        ll_znx.setOnClickListener(this)
        ll_dzh.setOnClickListener(this)
        ll_skgw.setOnClickListener(this)
        ll_slxw.setOnClickListener(this)
        ll_xttz.setOnClickListener(this)
        ll_pltz.setOnClickListener(this)
        ll_xqtz.setOnClickListener(this)
    }

    override fun onFragmentResume() {
        super.onFragmentResume()

        if (AppConfig.fragmentClickFlag == Constant.FRAGMENT_CLICK_FOUR) {

        }
    }

    override fun onClick(v: View?) {
        if (AntiShake.check(v?.id)) return

        when (v?.id) {
            R.id.ll_znx -> {
                val bundle = Bundle()
                bundle.putString(
                    CommonTabActivity.ACTIVITY_COMMON_TYPE,
                    CommonTabActivity.ACTIVITY_TYPE_ZNX
                )
                bundle.putInt(
                    CommonTabActivity.ACTIVITY_COMMON_POSITION,
                    0
                )
                readyGo(CommonTabActivity::class.java, bundle)
            }
            R.id.ll_dzh -> {
                val bundle = Bundle()
                bundle.putString(
                    CommonTabActivity.ACTIVITY_COMMON_TYPE,
                    CommonTabActivity.ACTIVITY_TYPE_DZH
                )
                bundle.putInt(
                    CommonTabActivity.ACTIVITY_COMMON_POSITION,
                    0
                )
                readyGo(CommonTabActivity::class.java, bundle)
            }
            R.id.ll_skgw -> {
                val bundle = Bundle()
                bundle.putString(
                    CommonTabActivity.ACTIVITY_COMMON_TYPE,
                    CommonTabActivity.ACTIVITY_TYPE_LLJL
                )
                bundle.putInt(
                    CommonTabActivity.ACTIVITY_COMMON_POSITION,
                    0
                )
                readyGo(CommonTabActivity::class.java, bundle)
            }
            R.id.ll_slxw -> {
                val bundle = Bundle()
                bundle.putString(
                    CommonTabActivity.ACTIVITY_COMMON_TYPE,
                    CommonTabActivity.ACTIVITY_TYPE_LXJL
                )
                bundle.putInt(
                    CommonTabActivity.ACTIVITY_COMMON_POSITION,
                    0
                )
                readyGo(CommonTabActivity::class.java, bundle)
            }
            R.id.ll_xttz -> {
                val bundle = Bundle()
                bundle.putString(
                    CommonTabActivity.ACTIVITY_COMMON_TYPE,
                    CommonTabActivity.ACTIVITY_TYPE_TZ
                )
                bundle.putInt(
                    CommonTabActivity.ACTIVITY_COMMON_POSITION,
                    0
                )
                readyGo(CommonTabActivity::class.java, bundle)
            }
            R.id.ll_pltz -> {
                val bundle = Bundle()
                bundle.putString(
                    CommonTabActivity.ACTIVITY_COMMON_TYPE,
                    CommonTabActivity.ACTIVITY_TYPE_TZ
                )
                bundle.putInt(
                    CommonTabActivity.ACTIVITY_COMMON_POSITION,
                    1
                )
                readyGo(CommonTabActivity::class.java, bundle)
            }
            R.id.ll_xqtz -> {
                val bundle = Bundle()
                bundle.putString(
                    CommonTabActivity.ACTIVITY_COMMON_TYPE,
                    CommonTabActivity.ACTIVITY_TYPE_TZ
                )
                bundle.putInt(
                    CommonTabActivity.ACTIVITY_COMMON_POSITION,
                    2
                )
                readyGo(CommonTabActivity::class.java, bundle)
            }
        }
    }
}