package com.duben.roseplaylet.ui.preview;

import android.app.Dialog;
import android.os.Bundle;
import android.view.View;

import com.duben.roseplaylet.R;
import com.google.android.material.bottomsheet.BottomSheetDialog;
import com.google.android.material.bottomsheet.BottomSheetDialogFragment;

/**
 * 描述：保存图片弹窗
 */
public class BottomDialogImagePreviewFragment extends BottomSheetDialogFragment implements View.OnClickListener {

    private OnDialogClickListener mOnDialogClickListener;

    /**
     * 按钮监听接口
     */
    public interface OnDialogClickListener {

        /**
         * 相册
         */
        void save();

        /**
         * 取消
         */
        void exit();
    }

    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        BottomSheetDialog dialog = (BottomSheetDialog) super.onCreateDialog(savedInstanceState);
        dialog.setContentView(R.layout.quick_bottom_image_preview);

//        save.setOnClickListener(this);
//        exit.setOnClickListener(this);

//        dialog.getWindow().findViewById(R.id.design_bottom_sheet)
//                .setBackgroundResource(R.color.full_transparent);

        return dialog;
    }

    @Override
    public void onClick(View v) {
        int i = v.getId();
        if (i == R.id.save) {
            mOnDialogClickListener.save();
            dismiss();
        } else if (i == R.id.exit) {
            mOnDialogClickListener.exit();
            dismiss();
        }
    }

    public static class Builder {

        private BottomDialogImagePreviewFragment mDialogFragment;

        public Builder() {
            mDialogFragment = new BottomDialogImagePreviewFragment();
        }

        public Builder setOnClickListener(OnDialogClickListener onClickListener) {
            mDialogFragment.mOnDialogClickListener = onClickListener;
            return this;
        }

        public BottomSheetDialogFragment builder() {
            return mDialogFragment;
        }
    }
}
