package com.duben.roseplaylet.ui.widgets

import android.app.Dialog
import android.content.Context
import android.content.Intent
import android.view.Gravity
import android.view.KeyEvent
import android.view.View
import android.view.WindowManager
import android.widget.ImageView
import com.duben.roseplaylet.R
import com.duben.roseplaylet.ui.activitys.RealAuthActivity

class RealAuthDialog(private val context: Context) : Dialog(
    context, R.style.dialog
) {
    private val lp: WindowManager.LayoutParams
    private val iv_phone_dialog_quit: ImageView
    private val iv_auth: ImageView

    init {
        setContentView(R.layout.dialog_real_auth)
        // 设置window属性
        lp = window!!.attributes
        lp.gravity = Gravity.CENTER
        lp.width = WindowManager.LayoutParams.MATCH_PARENT
        lp.windowAnimations = R.style.DialogAnimFade
        window!!.attributes = lp

        // 设置外部不可关闭
        setCancelable(false)
        setCanceledOnTouchOutside(false)
        setOnKeyListener { dialogInterface, i, keyEvent ->
            i == KeyEvent.KEYCODE_BACK
        }


        // 查找View
        iv_phone_dialog_quit = findViewById<View>(R.id.iv_phone_dialog_quit) as ImageView
        iv_auth = findViewById<View>(R.id.iv_auth) as ImageView
        iv_phone_dialog_quit.setOnClickListener {
            dismiss()
        }
        iv_auth.setOnClickListener {
            val intent = Intent(context, RealAuthActivity::class.java)
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            context.startActivity(intent)
            dismiss()

        }

    }

}