package com.duben.roseplaylet.ui.widgets

import android.app.Dialog
import android.content.Context
import android.graphics.Color
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import android.widget.TextView
import androidx.core.content.ContextCompat
import com.duben.roseplaylet.R
import com.duben.roseplaylet.utils.SpanUtils

class VipBackDialog(private val context: Context) : Dialog(context, R.style.dialog) {

    private val lp: WindowManager.LayoutParams
    private val tv_text1: TextView
    private val tv_text2: TextView
    private val tv_ok: TextView


    init {
        setContentView(R.layout.dialog_vip_back)
        // 设置window属性
        lp = window!!.attributes
        lp.gravity = Gravity.CENTER
        lp.width = WindowManager.LayoutParams.MATCH_PARENT
        lp.windowAnimations = R.style.DialogAnimBottom
        window!!.attributes = lp

        tv_text1 = findViewById<View>(R.id.tv_text1) as TextView
        tv_text2 = findViewById<View>(R.id.tv_text2) as TextView
        tv_ok = findViewById<View>(R.id.tv_ok) as TextView

        tv_text1.text = SpanUtils()
            .append("参与条件:")
            .setBold()
            .setForegroundColor(Color.BLACK)
            .append(" 全额返活动仅限带有“下单立返标签的会员套餐参与，购买套餐且开通自动续费持续30分钟以上的用户可获得全额返资格;")
            .setForegroundColor(ContextCompat.getColor(context,R.color.gray))
            .create()

        tv_text2.text = SpanUtils()
            .append("返还时间:")
            .setBold()
            .setForegroundColor(Color.BLACK)
            .append(" 获得资格的用户在购买套餐并开通自动续费后的30分钟内返还。")
            .setForegroundColor(ContextCompat.getColor(context,R.color.gray))
            .create()

        tv_ok.setOnClickListener { dismiss() }
    }
}