package com.duben.roseplaylet.utils

import android.content.Context
import com.duben.roseplaylet.mvp.model.CosumerAddressEntity
import com.duben.roseplaylet.mvp.model.JsonBean
import com.duben.roseplaylet.mvp.model.MainMultiItemEntity
import com.duben.roseplaylet.mvp.model.ProvinceCosumer
import com.google.gson.Gson
import org.json.JSONArray

object AddressData {

    private var cosumerAddressEntity: CosumerAddressEntity? = null

    /**
     * 解析省市区
     */
    fun getJsonData(context: Context): MainMultiItemEntity {
        val data = MainMultiItemEntity()
        try {
            val options2Items = arrayListOf<ArrayList<String>>()
            val options3Items = arrayListOf<ArrayList<ArrayList<String>>>()
            //解析数据
            val JsonData: String = GetJsonDataUtil().getJson(context, "province.json")
            val jsonBean: ArrayList<JsonBean> = parseData(JsonData)

            data.options1Items = jsonBean

            for (i in jsonBean.indices) { //遍历省份
                val cityList = ArrayList<String>() //该省的城市列表（第二级）
                val province_AreaList = ArrayList<ArrayList<String>>() //该省的所有地区列表（第三极）
                for (c in 0 until jsonBean[i].cityList.size) { //遍历该省份的所有城市
                    val cityName = jsonBean[i].cityList[c].name
                    cityList.add(cityName) //添加城市
                    val city_AreaList = ArrayList<String>() //该城市的所有地区列表

                    //如果无地区数据，建议添加空字符串，防止数据为null 导致三个选项长度不匹配造成崩溃
                    if (jsonBean[i].cityList[c].area == null
                        || jsonBean[i].cityList[c].area.size == 0
                    ) {
                        city_AreaList.add("")
                    } else {
                        city_AreaList.addAll(jsonBean[i].cityList[c].area);
                    }
//                city_AreaList.addAll(jsonBean[i].cityList[c].area)
                    province_AreaList.add(city_AreaList) //添加该省所有地区数据
                }
                /**
                 * 添加城市数据
                 */
                options2Items.add(cityList)
                /**
                 * 添加地区数据
                 */
                options3Items.add(province_AreaList)
            }
            data.options2Items = options2Items
            data.options3Items = options3Items
        } catch (e: Exception) {
            e.printStackTrace()
        }

        return data
    }

    /**
     * 解析省市
     */
    fun getJsonDataForProvince(context: Context): MainMultiItemEntity {
        val data = MainMultiItemEntity()
        try {
            //解析数据
            data.options1Items = parseData(GetJsonDataUtil().getJson(context, "province.json"))
        } catch (e: Exception) {
            e.printStackTrace()
        }
        return data
    }

    private fun parseData(result: String?): ArrayList<JsonBean> { //Gson 解析
        val detail = arrayListOf<JsonBean>()
        try {
            val data = JSONArray(result)
            val gson = Gson()
            for (i in 0 until data.length()) {
                val entity = gson.fromJson(data.optJSONObject(i).toString(), JsonBean::class.java)
                detail.add(entity)
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
        return detail
    }

    fun setLocalCosumerAddress(item: ArrayList<JsonBean>) {
        try {
            cosumerAddressEntity = CosumerAddressEntity()
            var options1Items = ArrayList<ProvinceCosumer>()
            var options2Items = ArrayList<ArrayList<String>>()
            for (i in 0 until item.size) {
                val provinceTest =
                    ProvinceCosumer(
                        i.toLong(),
                        item[i].name,
                        "描述部分",
                        "其他数据"
                    )
                val cityListTemp = arrayListOf<String>()

                for (j in 0 until item[i].cityList.size) {
                    cityListTemp.add(item[i].cityList[j].name)
                }
                options1Items.add(provinceTest)
                options2Items.add(cityListTemp)
            }
            cosumerAddressEntity?.options1Items = options1Items
            cosumerAddressEntity?.options2Items = options2Items
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

    fun getLocalCosumerAddress() = cosumerAddressEntity
}